﻿using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Diagram.Controls;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PalatteAddingProgramatically
{
    public partial class Form1 : Form
    {
        private PaletteGroupBar paletteBar;
        SymbolPalette symbol;
        private Node tempnode = null;
        private TextBox text;
        private Form2 form2;
        
        public Form1()
        {
            InitializeComponent();
            propertyEditor1.Diagram = this.diagram1;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Syncfusion.Windows.Forms.Diagram.Rectangle Rectangle = new Syncfusion.Windows.Forms.Diagram.Rectangle(100, 100, 100, 50);
            Rectangle.FillStyle.Color = Color.SkyBlue;
            Syncfusion.Windows.Forms.Diagram.Ellipse Ellipse = new Syncfusion.Windows.Forms.Diagram.Ellipse(0, 60, 100, 100);
            Ellipse.FillStyle.Color = Color.SeaGreen;

            Group grp = new Group();
            grp.AppendChild(Rectangle);
            grp.AppendChild(Ellipse);

            //Creates a Symbols programmatically
            symbol = new SymbolPalette();
            symbol.Name = "Symbol";
            symbol.AppendChild(Rectangle);
            symbol.AppendChild(Ellipse);
            symbol.AppendChild(grp);
            //Creates a PaletteGroupBar programmatically
            paletteBar = new PaletteGroupBar();
            paletteBar.Dock = DockStyle.Left;
            paletteBar.Font = new Font("Arial", 9);
            paletteBar.BorderStyle = BorderStyle.None;

            //Apply visual styles
            paletteBar.VisualStyle = Syncfusion.Windows.Forms.VisualStyle.Office2010;
            paletteBar.TextAlign = Syncfusion.Windows.Forms.Tools.TextAlignment.Left;

            paletteBar.ClientSize = new Size(200, 100);
            paletteBar.Collapsed = false;
            paletteBar.Enabled = true;
            paletteBar.Visible = true;            

            //Add symbols to palatte
            paletteBar.AddPalette(symbol);

            //Add paletteBar to the form
            this.diagram1.Controls.Add(paletteBar);
            diagram1.EventSink.NodeCollectionChanged += EventSink_NodeCollectionChanged;
        }

        void EventSink_NodeCollectionChanged(CollectionExEventArgs evtArgs)
        {
            //if (evtArgs.Element is Group)
            //{
            //    form2 = new Form2();
            //    tempnode = evtArgs.Element as Node;
            //    Button button = new Button();
            //    button.Text = "OK";
            //    button.Size = new System.Drawing.Size(100, 20);
            //    text = new TextBox();
            //    text.Multiline = true;
            //    text.Size = new Size(270, 150);
            //    if (!form2.Controls.Contains(text))
            //        form2.Controls.Add(text);
            //    if (!form2.Controls.Contains(button))
            //        form2.Controls.Add(button);
            //    form2.Location = new Point((int)diagram1.Controller.MouseLocation.X, (int)diagram1.Controller.MouseLocation.Y);
            //    text.Location = new Point(0, 0);
            //    button.Location = new Point(100, 160);
            //    button.Click += button_Click;
            //    form2.Show();
            //}
        }

        private void button_Click(object sender, EventArgs e)
        {
            if (tempnode != null && tempnode is Group)
            {
                if (tempnode.Name != string.Empty && text.Text != string.Empty)
                    tempnode.Name = text.Text;
            }
            form2.Hide();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if(diagram1.View.SelectionList.Count > 0)
            {
                Group grp = new Group();
                grp.Parent = diagram1.Model;
                grp.Name = "mysymbol";
                for (int i = 0; i < this.diagram1.View.SelectionList.Count; i++)
                {
                    Node nod = this.diagram1.View.SelectionList[i].Clone() as Node;
                    grp.AppendChild(nod);
                }

                form2 = new Form2();
                tempnode = grp as Node;
                Button button = new Button();
                button.Text = "OK";
                button.Size = new System.Drawing.Size(100, 20);
                text = new TextBox();
                text.Multiline = true;
                text.Size = new Size(270, 150);
                if (!form2.Controls.Contains(text))
                    form2.Controls.Add(text);
                if (!form2.Controls.Contains(button))
                    form2.Controls.Add(button);
                form2.Location = new Point((int)diagram1.Controller.MouseLocation.X, (int)diagram1.Controller.MouseLocation.Y);
                text.Location = new Point(0, 0);
                button.Location = new Point(100, 160);
                button.Click += button_Click;
                form2.Show();
                symbol.AppendChild(grp);
            }
        }
    }
}
